--Visual Lua Mod of MassiveFight
--Author: Engin33R
vl={}

function initArray2(f,v)
	local cmd={}
	for c=1,f do
		cmd[c]=v
	end
	return cmd
end

function doublearray(m,n,k)
    local a, x, y = {}
    for x = 0, m do a[x] = {}
        for y = 0, n do
            a[x][y] = k
        end
    end
    return a
end

function table.contains(table, element)
    for _, value in pairs(table) do
        if value == element then
            return true
        end
    end
    return false
end

vl.buttonstyles={ -- This is the button styles table - just follow the model of the first default style to create your own!
	[1] = {
		name="Default",
		image="gfx/button.png",
		hover="gfx/buttonhover.png",
		click="gfx/buttonclick.png",
		sizex=112,
		sizey=34,
		txtr=0,
		txtg=0,
		txtb=0,
		ox=-56,
		oy=-9,
	},
	--[[[2] = {
		name="Gray Man(BIG) by Razgriz",
		image="gfx/MassiveFight/vl/button.png",
		hover="gfx/MassiveFight/vl/button_hover.png",
		click="gfx/MassiveFight/vl/button_click.png",
		sizex=112,
		sizey=135,
		txtr=171,
		txtg=171,
		txtb=171,
		ox=0,
		oy=-9,
	},]]
	[2] = {
		name="Gate-in by Razgriz",
		image="gfx/MassiveFight/vl/button2.png",
		hover="gfx/MassiveFight/vl/button_hover_2.png",
		click="gfx/MassiveFight/vl/button_click_2.png",
		sizex=75,
		sizey=75,
		txtr=255,
		txtg=255,
		txtb=255,
		ox=0,
		oy=45,
	},
}

vl.windowstyles={ -- This is the window styles table - just follow the model of the first default style to create your own!
	[1] = {
		name="Default",
		image="gfx/sprites/block.bmp",
		sizex=32,
		sizey=32,
		bgr=100,
		bgg=100,
		bgb=100,
		brr=210,
		brg=216,
		brb=221,
		txtr=200,
		txtg=200,
		txtb=200,
		hlr=255,
		hlg=255,
		hlb=255,
	},
}

vl.currentTextID=1
vl.textpos=doublearray(1024,2,0)
vl.texttext=initArray2(1024,"")
vl.textcolor=initArray2(1024,"")

vl.plyInRange=initArray2(32,0)

vl.buttonimg=initArray2(1024,0)
vl.buttonpos=doublearray(1024,2,0)
vl.buttonsize=doublearray(1024,2,0)
vl.buttonply=initArray2(1024,0)
vl.buttonstyle=initArray2(1024,0)
vl.buttonfunc=initArray2(1024,nil)
vl.buttonhoveredupon=initArray2(1024,false)
vl.buttoncaption=initArray2(1024,0)
vl.buttonclicker=initArray2(1024,0)

vl.windowimg=initArray2(1024,0)
vl.windowbr=initArray2(1024,0)
vl.windowbr2=initArray2(1024,0)
vl.windowpos=doublearray(1024,2,0)
vl.windowsize=doublearray(1024,2,0)
vl.windowply=initArray2(1024,0)
vl.windowhl=initArray2(1024,0)

-- Function: createText
-- Arguments: ply - player to be shown the text, color - the text color, text - the text itself, x - pixel X coordinate on the screen, y - pixel Y coordinate on the screen
-- Possible argument values: ply - 1-32, color - "000000000"-"255255255" (any combination), text - any string, x - 0-640, y - 0-480
function vl.createText(ply,color,text,x,y,align)
	local formattext=(""..color.." "..text)
	local tid=vl.currentTextID
	if align~=nil then
		parse('hudtxt2 '..ply..' '..vl.currentTextID..' "'..formattext..'" '..x.." "..y.." "..align)
	else
		parse('hudtxt2 '..ply..' '..vl.currentTextID..' "'..formattext..'" '..x.." "..y)
	end
	vl.textpos[vl.currentTextID][1]=x
	vl.textpos[vl.currentTextID][2]=y
	vl.texttext[vl.currentTextID]=text
	vl.textcolor[vl.currentTextID]=color
	vl.currentTextID=vl.currentTextID+1
	return tid
end

-- Function: removeText
-- Arguments: id - text ID
-- Possible argument values: id - 1-1024
function vl.removeText(id)
	parse('hudtxt2 0 '..id..' "" 0 0')
	vl.textpos[id][1]=0
	vl.textpos[id][2]=0
	vl.texttext[id]=0
	vl.textcolor[id]=0
end

-- Function: createButton
-- Arguments: id - button ID, ply - player to be shown the button, x - button's X position on player's screen, y - button's Y position on player's screen, style - button's style
-- Possible argument values: id - 1-1024, ply - 0-32 (0 for all players), x - 0-640, y - 0-480, style - nil-any button style ID
function vl.createButton(id,ply,x,y,style,caption,func)
	if style==nil then style=1 end
	if ply==0 then ply=nil end
	vl.buttonimg[id]=image(vl.buttonstyles[style].image,x,y,2,ply)
	vl.buttonply[id]=ply
	vl.buttonpos[id][1]=x
	vl.buttonpos[id][2]=y
	vl.buttonsize[id][1]=vl.buttonstyles[style].sizex
	vl.buttonsize[id][2]=vl.buttonstyles[style].sizey
	vl.buttonstyle[id]=style
	vl.buttonfunc[id]=func
	if (caption~=nil) then
		vl.buttoncaption[id]=vl.createText(ply,colorcode(vl.buttonstyles[style].txtr,vl.buttonstyles[style].txtg,vl.buttonstyles[style].txtb),caption,x+vl.buttonstyles[style].ox,y+vl.buttonstyles[style].oy,1)
	end
end

function colorcode(r,g,b)
	if (tostring(r):len()==1) then
		r="00"..r
	elseif (tostring(r):len()==2) then
		r="0"..r
	end
	if (tostring(g):len()==1) then
		g="00"..g
	elseif (tostring(g):len()==2) then
		g="0"..g
	end
	if (tostring(b):len()==1) then
		b="00"..b
	elseif (tostring(b):len()==2) then
		b="0"..b
	end
	return r..""..g..""..b
end


-- Function: createWindow
-- Arguments: id - window ID, ply - player to be shown the window, x - window's X position on player's screen, y - window's Y position on player's screen, scalex - window's X scale factor, scaley - window's Y scale factor, border - should the window have borders?, style - window's style, headline - window's headline
-- Possible argument values: id - 1-1024, ply - 0-32 (0 for all players), x - 0-640, y - 0-480, scalex - 0-any, scaley - 0-any, border - true/false, style - nil-any button style ID, headline - any string
function vl.createWindow(id,ply,x,y,scalex,scaley,border,style,headline)
	if border==nil then border=0 end
	if ply==0 then ply=nil end
	if (border) then
		vl.windowbr[id]=image(vl.windowstyles[style].image,x,y,2,ply)
		vl.windowbr2[id]=image(vl.windowstyles[style].image,x,y,2,ply)
	end
	vl.windowimg[id]=image(vl.windowstyles[style].image,x,y,2,ply)
	imagescale(vl.windowimg[id],scalex,scaley)
	imagecolor(vl.windowimg[id],vl.windowstyles[style].bgr,vl.windowstyles[style].bgg,vl.windowstyles[style].bgb)
	vl.windowply[id]=ply
	vl.windowpos[id][1]=x
	vl.windowpos[id][2]=y
	vl.windowsize[id][1]=vl.windowstyles[style].sizex*scalex
	vl.windowsize[id][2]=vl.windowstyles[style].sizey*scaley
	if (border) then
		local offsety=(vl.windowstyles[style].sizey*(scaley+((scaley/60)*2)))-(vl.windowstyles[style].sizey*scaley)
		imagescale(vl.windowbr[id],scalex+(scalex/120),(scaley+(scaley/60))+((scaley/60)*3.5))
		imagepos(vl.windowbr[id],x,y-offsety,0)
		imagecolor(vl.windowbr[id],vl.windowstyles[style].brr,vl.windowstyles[style].brg,vl.windowstyles[style].brb)
		
		imagescale(vl.windowbr2[id],scalex+(scalex/120),scaley+(scaley/120))
		imagepos(vl.windowbr2[id],x,y,0)
		imagecolor(vl.windowbr2[id],0,0,0)
		
		if (headline~=nil) then
			if (scaley>=6) then
				vl.windowhl[id]=vl.createText(ply,colorcode(vl.windowstyles[style].hlr,vl.windowstyles[style].hlg,vl.windowstyles[style].hlb),headline,x-(vl.windowsize[id][1]/2)+24,y-(vl.windowsize[id][2]/2)-(offsety*2.1))
			else
				print("255000000VisualLua exception - headline for window #"..id.." could not be created (window size too small)")
			end
		end
	end
	if (not border and headline) then
		print("255000000VisualLua exception - headline for window #"..id.." could not be created (no border)")
	end
end

-- Function: closeWindow
-- Arguments: id - window ID
-- Possible argument values: id - 1-1024
function vl.closeWindow(id)
	freeimage(vl.windowimg[id])
	vl.windowimg[id]=0
	freeimage(vl.windowbr[id])
	vl.windowbr[id]=0
	freeimage(vl.windowbr2[id])
	vl.windowbr2[id]=0
	vl.removeText(vl.windowhl[id])
	vl.windowhl[id]=0
	vl.windowply[id]=0
	vl.windowpos[id][1]=0
	vl.windowpos[id][2]=0
	vl.windowsize[id][1]=0	
	vl.windowsize[id][2]=0
end

-- Function: hoverButton
-- Arguments: id - button ID, ply - player hovering over the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.hoverButton(id,ply)
	freeimage(vl.buttonimg[id])
	vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].hover,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
	vl.buttonhoveredupon[id]=true
end

-- Function: dehoverButton
-- Arguments: id - button ID, ply - player hovering over the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.dehoverButton(id,ply)
	if (vl.buttonhoveredupon[id]) then
		freeimage(vl.buttonimg[id])
		vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].image,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
		vl.buttonhoveredupon[id]=false
	end
end

-- Function: buttonCLick
-- Arguments: id - button ID, ply - player clicking the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.buttonClick(id,ply)
	freeimage(vl.buttonimg[id])
	vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].click,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
	vl.buttonclicker[id]=ply
	timer(100,"parse","lua vl.buttonUnclick("..id..","..ply..")")
end

-- Function: buttonUncLick
-- Arguments: id - button ID, ply - player clicking the button
-- Possible argument values: id - 1-1024, ply - 1-32
function vl.buttonUnclick(id,ply)
	if (vl.buttonimg[id]~=0) then
		freeimage(vl.buttonimg[id])
		vl.buttonimg[id]=image(vl.buttonstyles[vl.buttonstyle[id]].image,vl.buttonpos[id][1],vl.buttonpos[id][2],2,ply)
	end
	if (vl.buttonfunc[id]~=nil) then
		vl.buttonfunc[id]()
	end
	vl.buttonclicker[id]=0
end

-- Function: removeButton
-- Arguments: id - button ID
-- Possible argument values: id - 1-1024
function vl.removeButton(id)
	freeimage(vl.buttonimg[id])
	vl.buttonimg[id]=0
	vl.buttonply[id]=0
	vl.buttonpos[id][1]=0
	vl.buttonpos[id][2]=0
	vl.buttonsize[id][1]=0
	vl.buttonsize[id][2]=0
	vl.buttonstyle[id]=0
	vl.buttonfunc[id]=nil
	vl.buttonhoveredupon[id]=false
	vl.removeText(vl.buttoncaption[id])
	vl.buttoncaption[id]=0
	vl.buttonclicker[id]=0
end
	

addhook("clientdata","vl.read")
function vl.read(ply,type,a1,a2)
	if type==0 then
		for buttons=1,1024 do
			if (not player(ply,"bot")) then
				if (a1>=vl.buttonpos[buttons][1]-vl.buttonsize[buttons][1]/2 and a1<=vl.buttonpos[buttons][1]+vl.buttonsize[buttons][1]/2 and a2>=vl.buttonpos[buttons][2]-vl.buttonsize[buttons][2]/2 and a2<=vl.buttonpos[buttons][2]+vl.buttonsize[buttons][2]/2) then
					vl.hoverButton(buttons,ply)
					vl.plyInRange[ply]=buttons
					break
				else
					vl.dehoverButton(buttons,ply)
					vl.plyInRange[ply]=0
				end
			end
		end
	end
end

addhook("ms100","vl.send")
function vl.send()
	for ply=1,32 do
		if (player(ply,"exists")) then
			reqcld(ply,0)
		end
	end
end

addhook("attack","vl.click")
function vl.click(ply)
	if (vl.plyInRange[ply]~=0) then
		vl.buttonClick(vl.plyInRange[ply],ply)
	end
end

-- lua vl.func_ex1(1)
function vl.classmenu(id)
	vl.createWindow(1,1,320,240,20,12,true,1,"Select your class...")
	--[[vl.createButton(1,id,194,310,2,"Medic",function() vl.closeWindow(1) vl.removeButton(1) vl.removeButton(2) vl.removeButton(3) mf.pl.class_selected[id]=true mf.pl.class[id]=2 end)
	vl.createButton(2,id,314,310,2,"Sapper",function() vl.closeWindow(1) vl.removeButton(1) vl.removeButton(2) vl.removeButton(3) mf.pl.class_selected[id]=true mf.pl.class[id]=3 end)
	vl.createButton(3,id,434,310,2,"Ranger",function() vl.closeWindow(1) vl.removeButton(1) vl.removeButton(2) vl.removeButton(3) mf.pl.class_selected[id]=true mf.pl.class[id]=1 end)]]
	for i in ipairs(mf.class) do
		if i<=5 then
			local x=79+(i-1)*120
			vl.createButton(i,id,x,150,2,mf.class[i].name,function() vl.closeWindow(1) for i=1, total_keys do vl.removeButton(i) end mf.pl.class[id]=i mf.checkclass(id) end)
		elseif i>=6 and i<=10 then
			local x=79+(i-6)*120
			vl.createButton(i,id,x,250,2,mf.class[i].name,function() vl.closeWindow(1) for i=1, total_keys do vl.removeButton(i) end mf.pl.class[id]=i mf.checkclass(id) end)
		elseif i>=11 and i<=15 then
			local x=79+(i-11)*120
			vl.createButton(i,id,x,350,2,mf.class[i].name,function() vl.closeWindow(1) for i=1, total_keys do vl.removeButton(i) end mf.pl.class[id]=i mf.checkclass(id) end)
		end
	end
end

function mf.checkclass(id)
	local i=mf.class[mf.pl.class[id]]
	parse("speedmod "..id.." "..i.speed)
	parse("setarmor "..id.." "..i.armor)
	parse("setmaxhealth "..id.." "..i.maxhp)
	for _,j in ipairs(i.weapon) do
		parse("equip "..id.." "..j)
	end
	parse("setweapon "..id.." "..i.weapon[1])
	--[[if mf.cfg.suit_for_game then
		mf.gotopos(id)
	end]]
	if mf.pl.class_selected[id]~=true then
		if player(id,"team")==1 then
			msg(string.char(169).."255069000"..player(id,"name").."(T) choosed "..i.name.."!!!")
		elseif player(id,"team")==2 then
			msg(string.char(169).."028134238"..player(id,"name").."(CT) choosed "..i.name.."!!!")
		end
		mf.pl.class_selected[id]=true
	end
end

function mf.gotopos(id)
	if player(id,"team")==1 then
		parse("setpos "..id.." "..tgoto[1].." "..tgoto[2])
	elseif player(id,"team")==2 then
		parse("setpos "..id.." "..ctgoto[1].." "..ctgoto[2])
	end
end